package main

import (
	"reflect"
	"fmt"
)

type Test struct {
}

func (this *Test)test() {
	fmt.Println("in test()")
}

type Tester interface {
	test()
}

func MakeTest1(v Tester) {
	fmt.Printf("\nIn Maketest1\n")
	v.(Tester).test()
}

func MakeTest2(v interface{}) {
	fmt.Printf("\nIn Maketest2\n")
	v.(Tester).test()
}

func main() {
	t := new(Test)
	var ti Tester
	ti = t
	ti.test()

	// 接口类型断言
	// value为Test类型的对象
	// 是ti的值
	value := ti.(Tester)
	fmt.Printf("\n方式1:\n")
	fmt.Println(reflect.TypeOf(value))
	value.test()

	// v是ti的值，是Test类型
	// Tester是接口类型
	if v, ok := ti.(Tester); ok {
		fmt.Printf("\n方式2:\n")
		fmt.Println(reflect.TypeOf(v))
		v.test()
	}

	// switch type专用组合
	// 如果需要在if中判断可以用上面的形式
	switch t := ti.(type) {
	case Tester:
		fmt.Printf("\n方式3:\n")
		fmt.Println("Tester")
		fmt.Println(reflect.TypeOf(t))
		t.test()
	default:
		fmt.Println("Unknow")
	}

	// 传递Test结构变量
	// 因为Test实现了Tester接口 
	MakeTest1(t)

	// 传递Tester接口变量
	MakeTest1(ti)

	// 传递Test结构变量
	// 因为Test实现了interface{}接口
	MakeTest2(t)

	// 传递Tester接口变量
	// 因为任何类型都实现了interface{}
	MakeTest2(ti)

}
